/**************************************************************************************************
*                                                                                                 *
*  Class name:   employeeEntry                                                                    *
*                                                                                                 *
*     Purpose:   Extends Panel to allow users to add new employees to the database.               *
*                                                                                                 *
*     Imports:  java.awt.*                                                                        *
*               java.applet.*                                                                     *
*               symjava.sql.*                                                                     *
*               java.net.*                                                                        *
*               java.lang.*                                                                       *
*               java.util.*                                                                       *
*                                                                                                 *
*  Methods include:  public boolean handleEvent(Event event)                                      *
*                    public employeeEntry(Applet parent)                                          *
*                    public String checkFields()                                                  *
*                    public synchronized void show()                                              *
*                    public void clickedclearbutton()                                             *
*                    public void clickedMainMenubutton()                                          *
*                    public void clickedSavebutton()                                              *
*                    public void getMessageBox(String msg)                                        *
*                                                                                                 *
* Additional Notes:                                                                               *
* THIS SOFTWARE HAS BEEN COMPILED AND EXECUTED SUCCESSFULLY IN SPECIFIC SYMANTEC                  *
* ENVIRONMENTS, AND IS BEING PROVIDED ONLY AS SAMPLE CODE.                                        *
*                                                                                                 *
* SYMANTEC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE SOFTWARE,          *
* EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF               *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SYMANTEC SHALL NOT     *
* BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING, OR DISTRIBUTING *
* THIS SOFTWARE OR ITS DERIVATIVES.                                                               *
*                                                                                                 *
*  Please see the Sample Code Configuration item in the Read Me file for additional               *
*  information about the sample database used in this applet.                                     *
*                                                                                                 *
* Copyright (c) 1996 Symantec.  All Rights Reserved.                                              *
*                                                                                                 *
**************************************************************************************************/

import java.applet.*;
import java.net.*;
import java.awt.*;
import symjava.sql.*;
import java.lang.*;
import java.util.*;

public class employeeEntry extends Panel {

    expenseApplet exp;
    public employeeEntry(Applet parent) {


        exp = (expenseApplet)parent;

        //{{INIT_CONTROLS
        setLayout(null);

        insets().left -= 60;
        resize(insets().left + insets().right + 770, insets().top + insets().bottom + 390);


        firstname=new TextField(22);
        add(firstname);
        firstname.reshape(insets().left + 134,insets().top + 54,190,25);

        label2=new Label("First Name");
        add(label2);
        label2.reshape(insets().left + 8,insets().top + 51,80,15);

        label3=new Label("Last Name");
        add(label3);
        label3.reshape(insets().left + 8,insets().top + 94,80,15);

        lastname=new TextField(22);
        add(lastname);
        lastname.reshape(insets().left + 134,insets().top + 88,190,25);

        label4=new Label("Address");
        add(label4);
        label4.reshape(insets().left + 8,insets().top + 128,80,15);

        address=new TextField(31);
        add(address);
        address.reshape(insets().left + 134,insets().top + 126,190,25);

        city=new TextField(22);
        add(city);
        city.reshape(insets().left + 134,insets().top + 163,190,25);

        label5=new Label("City");
        add(label5);
        label5.reshape(insets().left + 8,insets().top + 167,80,15);

        label6=new Label("State");
        add(label6);
        label6.reshape(insets().left + 8,insets().top + 203,100,15);

        state=new TextField(9);
        add(state);
        state.reshape(insets().left + 134,insets().top + 203,190,25);

        label7=new Label("Postal Code");
        add(label7);
        label7.reshape(insets().left + 8,insets().top + 242,80,15);

        postalcode=new TextField(9);
        add(postalcode);
        postalcode.reshape(insets().left + 134,insets().top + 242,190,25);

        title=new TextField(21);
        add(title);
        title.reshape(insets().left + 470,insets().top + 51,190,25);

        label8=new Label("Title");
        add(label8);
        label8.reshape(insets().left + 352,insets().top + 54,70,15);

        label9=new Label("Employee #");
        add(label9);
        label9.reshape(insets().left + 352,insets().top + 94,100,15);

        employeenum=new TextField(14);
        add(employeenum);
        employeenum.reshape(insets().left + 470,insets().top + 88,190,25);

        label10=new Label("Social Security #");
        add(label10);
        label10.reshape(insets().left + 352,insets().top + 128,105,15);

        socialsecurity=new TextField(13);
        add(socialsecurity);
        socialsecurity.reshape(insets().left + 470,insets().top + 126,190,25);

        email=new TextField(20);
        add(email);
        email.reshape(insets().left + 470,insets().top + 163,190,25);

        label11=new Label("Email");
        add(label11);
        label11.reshape(insets().left + 352,insets().top + 167,80,15);

        label12=new Label("Dept Name");
        add(label12);
        label12.reshape(insets().left + 352,insets().top + 203,80,15);

        deptname=new TextField(20);
        add(deptname);
        deptname.reshape(insets().left + 470,insets().top + 203,190,25);

        label13=new Label("Home Phone");
        add(label13);
        label13.reshape(insets().left + 352,insets().top + 242,85,15);

        homephone=new TextField(13);
        add(homephone);
        homephone.reshape(insets().left + 470,insets().top + 242,190,25);

        label14=new Label("Country");
        add(label14);
        label14.reshape(insets().left + 8,insets().top + 278,80,15);

        country=new TextField(21);
        add(country);
        country.reshape(insets().left + 134,insets().top + 278,190,25);

        label15=new Label("Work Phone");
        add(label15);
        label15.reshape(insets().left + 352,insets().top + 278,80,15);

        workphone=new TextField(13);
        add(workphone);
        workphone.reshape(insets().left + 470,insets().top + 278,190,25);

        savebutton=new Button("Save");
        add(savebutton);
        savebutton.reshape(insets().left + 230,insets().top + 320,88,26);

        clearbutton=new Button("Clear");
        add(clearbutton);
        clearbutton.reshape(insets().left + 330,insets().top + 320,88,26);

        MainMenubutton=new Button("Main Menu");
        add(MainMenubutton);
        MainMenubutton.reshape(insets().left + 430,insets().top + 320,88,26);
        //}}


    }

    public synchronized void show() {
    	super.show();
    }

    //{{DECLARE_CONTROLS
    TextField firstname;
    Label label2;
    Label label3;
    TextField lastname;
    Label label4;
    TextField address;
    TextField city;
    Label label5;
    Label label6;
    TextField state;
    Label label7;
    TextField postalcode;
    TextField title;
    Label label8;
    Label label9;
    TextField employeenum;
    Label label10;
    TextField socialsecurity;
    TextField email;
    Label label11;
    Label label12;
    TextField deptname;
    Label label13;
    TextField homephone;
    Label label14;
    TextField country;
    Label label15;
    TextField workphone;
    Label titlelabel;
    Button savebutton;
    Button clearbutton;
    Button MainMenubutton;
    //}}



    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == savebutton) {
            clickedSavebutton();
    	    return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == clearbutton) {
            clickedclearbutton();
    	    return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == MainMenubutton) {
            clickedMainMenubutton();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

/*
    public void getMessageBox(String msg) {
        MessageBox theMessageBox;
        theMessageBox = new MessageBox(this, msg);
        theMessageBox.show();
    }
*/
    public void clickedMainMenubutton() {
       hide();
    }
    public void clickedSavebutton() {
        Statement  s;
        int rs = 0;

        String fName = "'" + firstname.getText() + "' ,";
        String lName = "'" + lastname.getText() + "' ,";
        String theAdd = "'" + address.getText() + "' ,";
        String theCity = "'" + city.getText() + "' ,";
        String theState = "'" + state.getText() + "' ,";
        String theZip = "'" + postalcode.getText() + "' ,";
        String theCountry = "'" + country.getText() + "' ,";
        String theTitle = "'" + title.getText() + "' ,";
        String theEmpnum = "'" + employeenum.getText() + "' ,";
        String theSSnum = "'" + socialsecurity.getText() + "' ,";
        String theEmail = "'" + email.getText() + "' ,";
        String theDept = "'" + deptname.getText() + "' ,";
        String theHome = "'" + homephone.getText() + "' ,";
        String theWork = "'" + workphone.getText() + "' ";

        //String sqlStatement = "Insert into Employees (DepartmentName, SocialSecurityNumber, EmployeeNumber, FirstName, LastName, Title, EmailName, Address, City, StateOrProvince, PostalCode, Country, HomePhone, WorkPhone) values (" + theDept + theSSnum + theEmpnum + fName + lName + theTitle + theEmail + theAdd + theCity + theState + theZip + theCountry + theHome + theWork + ")";
        String sqlStatement = "Insert into Employees (EmployeeID, DepartmentName, SocialSecurityNumber, EmployeeNumber, FirstName, LastName, Title, EmailName, Address, City, StateOrProvince, PostalCode, Country, HomePhone, WorkPhone) values (" + theSSnum + theDept + theSSnum + theEmpnum + fName + lName + theTitle + theEmail + theAdd + theCity + theState + theZip + theCountry + theHome + theWork + ")";

        /*****************   Insert Data to Employeess Table   *****************************************/
        String errMessage = "";
        errMessage = checkFields();

        if (errMessage.equals("") ){
            try
            {
                s = (Statement)exp.connection.createStatement();
                rs = s.executeUpdate(sqlStatement);
                s.close();
             }

            catch (SQLException e)
            {
                System.out.println(e.getMessage());
                return;
            }
        }
        else {
           // getMessageBox(errMessage);
        }
        /************************************************************************************************/
    }

//****  clear all entry fields  ******
    public void clickedclearbutton() {
        firstname.setText(null);
        lastname.setText(null);
        address.setText(null);
        city.setText(null);
        state.setText(null);
        postalcode.setText(null);
        country.setText(null);
        title.setText(null);
        employeenum.setText(null);
        socialsecurity.setText(null);
        email.setText(null);
        deptname.setText(null);
        homephone.setText(null);
        workphone.setText(null);
    }

//****  check to see that all fields are entered before save  *****
    public String checkFields() {
        String errMessage = "";

        if (workphone.getText().equals(""))
            errMessage =  "Please enter Work phone        ";
        if (deptname.getText().equals(""))
            errMessage =  "Please enter Dept Name          ";
        if (socialsecurity.getText().equals(""))
            errMessage =  "Please enter Social Security #  ";
        if (employeenum.getText().equals(""))
            errMessage =  "Please enter Employee #       ";
        if (title.getText().equals(""))
            errMessage =  "Please enter Title            ";
        if (country.getText().equals(""))
            errMessage =  "Please enter Country          ";
        if (postalcode.getText().equals(""))
            errMessage =  "Please enter Postal Code      ";
        if (state.getText().equals(""))
            errMessage =  "Please enter State            ";
        if (city.getText().equals(""))
            errMessage =  "Please enter City             ";
        if (address.getText().equals(""))
            errMessage =  "Please enter Address          ";
        if (lastname.getText().equals(""))
            errMessage =  "Please enter Last name        ";
        if (firstname.getText().equals(""))
            errMessage =  "Please enter First name       ";

        return errMessage;
    }
}

